{A partial 6502, just to get my feet wet!}

CON
  ' Set up the processor clock in the standard way for 80MHz on HYBRID
  ' You will want to edit this to reflect your clock setup
  ' Also necessary is editing the pin definitions, and that's done in the driver itself.
_CLKMODE = xtal1 + pll16x
_XINFREQ = 6_000_000 + 0000

VAR

  word    pc
  long    clock
  byte    A, X, Y, SR, FR
  byte    instruction
  word    address
  byte    addressl
  byte    addressh
  byte    ALU


PUB execute (start_address)

    init_registers
    PC := start_address

    repeat 500000
      fetch_opcode(PC)
      compute

    

PUB compute

    case instruction
       $a9 : LDA_immediate      'LDA #xx
       $a2 : LDX_immediate      'LDX #xx
       $9d : STA_abs_x          'STA $xxxx, X
       $ca : DEX                'DEX
       $e0 : CPX_immediate      'CPX #xx
       $d0 : BNE_immediate      'BNE #xx
       $a0 : LDY_immediate      'LDY #xx
       $fe : INC_abs_x          'INC $xxxx, X
       $44 : CMP_immediate      'CMP #xx
       $98 : TYA                'TYA
       $bd : LDA_abs_x          'LDA $xxxx, X
       

PRI LDA_abs_x
    addressl := byte[PC]
    PC++
    addressh := byte[PC]
    PC++
    address := addressl + addressh << 8
    A := byte [address] [X]



PRI TYA
    A := Y

PRI CMP_immediate
    ALU := byte[PC]
    PC++
    if A == ALU
       FR := 1
    else
       FR := 0       
       
PRI LDY_immediate
    Y := byte[PC]
    PC++

PRI LDA_immediate
    A := byte[PC]
    PC++

PRI LDX_immediate
    X := byte[PC]
    PC++

PRI INC_abs_x
    addressl := byte[PC]
    pc++
    addressh := byte[PC]
    pc++
    address := addressl + addressh << 8
    ALU := byte [address] [X]
    ALU++
    byte [address] [X] := ALU

PRI STA_abs_x
    addressl := byte[PC]
    PC++
    addressh := byte[PC]
    PC++
    address := addressl + addressh << 8
    byte [address] [X] := A

PRI DEX
    X--

PRI CPX_immediate
    ALU := byte[PC]
    PC++
    if X == ALU
       FR := 1
    else       
       FR := 0

PRI BNE_immediate
    ALU := byte[PC]
    PC++
    if FR == 1
      RETURN
    PC := PC + ($FF << 8 + ALU) 'Sign extend and add to PC, still a hack, but one that works better...


PRI fetch_opcode (read_address)
      instruction := byte [read_address]
      PC++



PRI init_registers
    A := 0
    X := 0
    Y := 0
    SR := 0
    FR := 0
    